MODULE ctest;
  FROM COMPLEX1 IMPORT Complex, CADD, CSUB, CMUL, CDIV, CNEG, CMPLX,
                      CLOG, CEXP, CSIN, CCOS, CSQRT, ARC, CABS;
  FROM IO IMPORT WrLngReal, WrReal, WrLn;
  IMPORT COMPLEX;
  VAR i : Complex;
  VAR X, IX, Y, Z : Complex;
  VAR ii:COMPLEX. Complex;
  VAR XX, IXX, YY, ZZ : COMPLEX . Complex;
BEGIN
  i:=CSQRT(Complex(-1.0,0.0));
  X.Re:=2.4; X.Im:=1.3;
  WrLngReal(CABS(CNEG(X\CMUL\X) \CADD\
                 CEXP(Complex(2.0,0.0)\CMUL\CLOG(X))),16,25); WrLn;
  IX:=i \CMUL\ X;
  Y:=(CEXP(IX) \CSUB\ CEXP(CNEG(IX))) \CDIV\ (CMPLX(2.0,0.0) \CMUL\ i);
  Z:=CSIN(X);
  WrLngReal(CABS(Y \CSUB\ Z),16,25); WrLn;
  Y:=(CEXP(IX) \CADD\ CEXP(CNEG(IX))) \CDIV\ Complex(2.0,0.0);
  Z:=CCOS(X);
  WrLngReal(CABS(Y \CSUB\ Z),16,25); WrLn;
  COMPLEX.CSQRT(COMPLEX.Complex(-1.0,0.0),ii);
  XX.Re:=2.4; XX.Im:=1.3;
  COMPLEX.CMUL(XX,XX,YY);
  COMPLEX.CNEG(YY,YY);
  COMPLEX.CLOG(XX,ZZ);
  COMPLEX.CMUL(COMPLEX.Complex(2.0,0.0),ZZ,ZZ);
  COMPLEX.CEXP(ZZ,ZZ);
  COMPLEX.CADD(YY,ZZ,ZZ);
  WrReal(COMPLEX.CABS(ZZ),16,25); WrLn;
  COMPLEX.CMUL(ii,XX,IXX);
  COMPLEX.CEXP(IXX,YY);
  COMPLEX.CNEG(IXX,ZZ);
  COMPLEX.CEXP(ZZ,ZZ);
  COMPLEX.CSUB(YY,ZZ,YY);
  COMPLEX.CMPLX(2.0,0.0,ZZ);
  COMPLEX.CMUL(ZZ,ii,ZZ);
  COMPLEX.CDIV(YY,ZZ,YY);
  COMPLEX.CSIN(XX,ZZ);
  COMPLEX.CSUB(YY,ZZ,YY);
  WrReal(COMPLEX.CABS(YY),16,25); WrLn;
  COMPLEX.CMUL(ii,XX,IXX);
  COMPLEX.CEXP(IXX,YY);
  COMPLEX.CNEG(IXX,ZZ);
  COMPLEX.CEXP(ZZ,ZZ);
  COMPLEX.CADD(YY,ZZ,YY);
  COMPLEX.CDIV(YY,COMPLEX.Complex(2.0,0.0),YY);
  COMPLEX.CCOS(XX,ZZ);
  COMPLEX.CSUB(YY,ZZ,YY);
  WrReal(COMPLEX.CABS(YY),16,25); WrLn;
END ctest.
