IMPLEMENTATION MODULE HILFE;

FROM ChipIO IMPORT
  ReadKey, MaxScreen, ScreenPtr, Write, WriteString, WriteLn,
  SelWindow, OpenWindow, OpenWindowHeader, CloseWindow;

FROM MENUE IMPORT
  MenueString, Auswahl;

FROM TEXTFILES IMPORT
  TextFile, Done, ResetTextFile, CloseTextFile, ReadCard,
  ReadString, ReadLn, Read;

PROCEDURE Hilfe(hcs : MenueString);
  CONST helpend = 'helpend';
  VAR SubHelp : ARRAY [1..10] OF MenueString;
      Help : MenueString;
      HelpFile : TextFile;
      Wahl, temp : CARDINAL;
      x1, y1, x2, y2  : CARDINAL;
      i : CARDINAL;
      c : CHAR;

  PROCEDURE EQUAL(X, Y : ARRAY OF CHAR) : BOOLEAN;
    VAR k : CARDINAL;
    BEGIN
      k:=0;
      WHILE (k<=HIGH(X)) AND (k<=HIGH(Y)) DO
        IF X[k]<>Y[k] THEN RETURN FALSE END;
        IF X[k]=0C THEN RETURN TRUE END;
        INC(k)
      END;
      IF k<=HIGH(X) THEN RETURN X[k]=0C END;
      IF k<=HIGH(Y) THEN RETURN Y[k]=0C END;
      RETURN TRUE
    END EQUAL;

  PROCEDURE APPEND(VAR X : ARRAY OF CHAR; Y : ARRAY OF CHAR);
    VAR xp, yp : CARDINAL;
    BEGIN
      xp:=0; yp:=0;
      WHILE (xp<=HIGH(X)) AND (X[xp]<>0C) DO INC(xp) END;
      WHILE (xp<=HIGH(X)) AND (yp<=HIGH(Y)) AND (Y[yp]<>0C) DO
        X[xp]:=Y[yp];
        INC(xp); INC(yp)
      END;
      IF xp<=HIGH(X) THEN X[xp]:=0C END
    END APPEND;

  PROCEDURE WarteAufESC;
    VAR C : CHAR;
    BEGIN
      REPEAT
        C:=ReadKey()
      UNTIL C=33C
    END WarteAufESC;

  BEGIN
    temp:=ScreenPtr;
    ResetTextFile(HelpFile,HelpFileName);
    IF NOT Done
    THEN
      OpenWindowHeader(20,12,60,15,' Fehler! ');
      WriteString('Hilfstext nicht gefunden!'); WriteLn;
      WriteString('Bitte <ESC> drcken '); WarteAufESC;
      CloseWindow;
      RETURN
    END;
    REPEAT
      ReadString(HelpFile,SubHelp[1]);
      IF Done THEN ReadLn(HelpFile) END;
    UNTIL (NOT Done) OR EQUAL(SubHelp[1],hcs);
    IF NOT Done
    THEN
      CloseTextFile(HelpFile);
      RETURN
    END;
    ReadCard(HelpFile,x1);
    ReadCard(HelpFile,y1);
    ReadCard(HelpFile,x2);
    ReadCard(HelpFile,y2);
    ReadLn(HelpFile);
    OpenWindow(x1,y1,x2,y2);
    REPEAT
      Read(HelpFile,c);
      IF c<>'#' THEN Write(c) END
    UNTIL (c='#') OR (NOT Done); ReadLn(HelpFile);
    i:=0;
    REPEAT
      INC(i);
      ReadString(HelpFile,SubHelp[i]); ReadLn(HelpFile);
    UNTIL (i=10) OR EQUAL(SubHelp[i],helpend);
    IF EQUAL(SubHelp[i],helpend) THEN DEC(i) END;
    CloseTextFile(HelpFile);
    IF i=0
    THEN
      WarteAufESC
    ELSE
      OpenWindowHeader(x2-14,y2-i-2,x2-1,y2-1,' Hilfen: ');
      Wahl:=1;
      REPEAT
        Auswahl(1,1,10,1,i,SubHelp,"",TRUE,TRUE,Wahl,c);
        IF (c<>33C) AND (Wahl>=1) AND (Wahl<=i)
          THEN
            Help:='';
            APPEND(Help,'#');
            APPEND(Help,SubHelp[Wahl]);
            Hilfe(Help)
          END;
      UNTIL c=33C;
      CloseWindow;
    END;
    CloseWindow;
    SelWindow(temp)
  END Hilfe;

END HILFE.
