MODULE SortTest;

FROM SORT IMPORT InitSort, SortError, ToSort, FromSort, CallSort, SortEmpty;
FROM InOut IMPORT Write, WriteCard, WriteString, WriteLn;
FROM RAND IMPORT Random;

TYPE StringType = ARRAY[0..80] OF CHAR;

PROCEDURE kleiner(X,Y : ADDRESS):BOOLEAN;
  VAR SX, SY : POINTER TO StringType;
      i : CARDINAL;
  BEGIN
    i:=0; (* Strings mssen mit 0C abgeschlossen sein *)
    LOOP
      IF SX^[i]<SY^[i] THEN RETURN TRUE
      ELSIF (SX^[i]>SY^[i]) OR (SX^[i]=0C) THEN RETURN FALSE
      ELSE INC(i)
      END (* IF *)
    END (* LOOP *)
  END kleiner;

PROCEDURE RandomString(VAR S : StringType; l : CARDINAL);
  BEGIN
    S[l]:=0C;
    WHILE l>0 DO
      S[l-1]:=CHR(65+TRUNC(26.*Random()));
      DEC(l)
    END (* WHILE *)
  END RandomString;

VAR  Line : StringType;
     i : CARDINAL;

BEGIN
  InitSort; i:=0;
  WHILE NOT SortError DO
    INC(i); WriteCard(i,1); Write(15C);
    RandomString(Line,40); ToSort(Line)
  END;
  WriteString(" Zeilen."); WriteLn;
  CallSort(kleiner);
  WHILE NOT SortEmpty() DO
    FromSort(Line);
    WriteString(Line); WriteLn
  END;

END SortTest.
